#--
# Copyright(C) 2013-2015 Giovanni Capuano <webmaster@giovannicapuano.net>
#
# This file is part of sottolio.
#
# sottolio is free software: you can redistribute it and/or modify
# it under the terms of the GNU General Public License as published by
# the Free Software Foundation, either version 3 of the License, or
# (at your option) any later version.
#
# sottolio is distributed in the hope that it will be useful,
# but WITHOUT ANY WARRANTY; without even the implied warranty of
# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
# GNU General Public License for more details.
#
# You should have received a copy of the GNU General Public License
# along with sottolio.  If not, see <http://www.gnu.org/licenses/>.
#++
module Sottolio
  class Lock
    def initialize
      @callbacks    = []
      @bootstrapped = false
      free!
    end

    def locked?
      @lock == true
    end

    def free?
      not locked?
    end

    def lock!
      @lock = true
    end

    def free!
      @lock = false
      @callbacks.shift.call unless @callbacks.empty?
    end

    def on_free(&block)
      unless locked? && @bootstrapped
        @bootstrapped = true
        block.call
      else
        @callbacks << block
      end
    end
  end
end
